#region Copyright Syncfusion Inc. 2001 - 2012
//
//  Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace EssentialDocIOSamples
{

    public class Form1 : System.Windows.Forms.Form
    {
        #region Private Members

        private ToolTip toolTip1;
        private Button button1;
        private PictureBox pictureBox1;
        private Label label2;
        private IContainer components;

        #endregion

        #region Constructor, Main and Dispose
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            Application.EnableVisualStyles();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }
        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.button1 = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.label2 = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button1.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button1.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button1.Location = new System.Drawing.Point(513, 256);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(96, 29);
            this.button1.TabIndex = 62;
            this.button1.Text = "Generate";
            this.button1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(0, 0);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(623, 112);
            this.pictureBox1.TabIndex = 60;
            this.pictureBox1.TabStop = false;
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(161)));
            this.label2.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label2.Location = new System.Drawing.Point(8, 123);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(440, 51);
            this.label2.TabIndex = 68;
            this.label2.Text = "Click the button to view the Word document generated by Essential DocIO. Please n" +
    "ote that MS Word Viewer or MS Word is required to view the resultant document.";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(623, 371);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Generate Word";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        #region Button_Click Event
        private void button1_Click(object sender, System.EventArgs e)
        {
            //Getting Image files path.
            string dataPath = Application.StartupPath + @"\..\..\Data\Template.docx";

            WordDocument document = new WordDocument(dataPath);

            //Gets table from the document.
            WTable table = document.LastSection.Body.ChildEntities[0] as WTable;

            //Creates pictures.
            WPicture picture = new WPicture(document);
            Image image = Image.FromFile(@"..\..\Data\image.png");
            picture.LoadImage(image);

            //Gets the table cell from table.
            WTableCell tableCell = table.Rows[0].Cells[0];

            //Gets spacings of table cell.
            float cellSpacing = GetSpacings(tableCell);
            //Gets paddings of table cell.
            float left = GetLeftPadding(tableCell);
            float right = GetRightPadding(tableCell);

            //Gets the client width of cell excluding the margins and spacing values.
            float clientWidth = tableCell.Width - (left + right) - (cellSpacing * 2);
            float scalePercentage = 100;
            //Calculates value for width scale factor.
            if (picture.Width > clientWidth)
            {
                scalePercentage = clientWidth / picture.Width * 100;
                //This will resizes the width.
                picture.WidthScale *= scalePercentage / 100;
            }

           
            //Gets paddings of table cell.
            float top = GetTopPadding(tableCell);
            float bottom = GetBottomPadding(tableCell);
            //Get the row height
            float clientHeight = tableCell.OwnerRow.Height - (top + bottom) - (cellSpacing * 2);

            scalePercentage = 100;
            //Calculates value for height scale factor.
            if (clientHeight >0 && picture.Height > clientHeight)
            {
                scalePercentage = clientHeight / picture.Height * 100;
                //This will resizes the height.
                picture.HeightScale *= scalePercentage / 100;
            }
            //Adds picture to the table cell.
            tableCell.AddParagraph().Items.Add(picture);

            //Saving the document as .docx
            document.Save("Sample.docx", FormatType.Docx);
            //Message box confirmation to view the created document.
            if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
            {
                try
                {
                    //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                    System.Diagnostics.Process.Start("Sample.docx");
                    //Exit
                    this.Close();
                }
                catch (Win32Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
            // Exit
            this.Close();

        }
        /// <summary>
        /// Gets spacings in the table cell.
        /// </summary>
        /// <param name="cell"></param>
        /// <returns></returns>
        private static float GetSpacings(WTableCell cell)
        {
            float cellSpacing = 0;
            //Gets the spacing value from the row format.
            if (cell.OwnerRow != null && (cell.OwnerRow as WTableRow).RowFormat.CellSpacing > 0)
                cellSpacing = (cell.OwnerRow as WTableRow).RowFormat.CellSpacing;
            //Gets the spacing value from the table format.
            else if (cell.OwnerRow != null && cell.OwnerRow.Owner != null && (cell.OwnerRow.Owner as WTable).TableFormat.CellSpacing > 0)
                cellSpacing = (cell.OwnerRow.Owner as WTable).TableFormat.CellSpacing;
            return cellSpacing;
        }
        /// <summary>
        /// Gets left margin of the table cell.
        /// </summary>
        /// <param name="cell">Represents the table cell</param>
        /// <returns>Returns left padding value of cell.</returns>
        private float GetLeftPadding(WTableCell cell)
        {
            //Gets padding from cell format.
            float left = cell.CellFormat.Paddings.Left;
            //If cell has same padding as table, then get the paddings from row or table.
            if (cell.CellFormat.SamePaddingsAsTable)
            {
                WTable table = (cell.OwnerRow.Owner as WTable);
                //Gets the left paddings from row format.
                if (cell.OwnerRow.RowFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.LeftKey))
                    left = cell.OwnerRow.RowFormat.Paddings.Left;
                //Gets the left paddings from table format.
                else if (table.TableFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.LeftKey))
                    left = table.TableFormat.Paddings.Left;
                //Default value for cell paddings.
                else
                    left = 5.4f;

            }
            return left;
        }
        /// <summary>
        /// Gets top margin of the table cell.
        /// </summary>
        /// <param name="cell">Represents the table cell</param>
        /// <returns>Returns top padding value of cell.</returns>
        private float GetTopPadding(WTableCell cell)
        {
            //Gets padding from cell format.
            float top = cell.CellFormat.Paddings.Top;
            //If cell has same padding as table, then get the paddings from row or table.
            if (cell.CellFormat.SamePaddingsAsTable)
            {
                WTable table = (cell.OwnerRow.Owner as WTable);
                //Gets the left paddings from row format.
                if (cell.OwnerRow.RowFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.TopKey))
                    top = cell.OwnerRow.RowFormat.Paddings.Top;
                //Gets the top paddings from table format.
                else if (table.TableFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.TopKey))
                    top = table.TableFormat.Paddings.Top;
                //Default value for cell paddings.
                else
                    top = 0;

            }
            return top;
        }
        /// <summary>
        /// Gets right margin of the table cell.
        /// </summary>
        /// <param name="cell">Represents the table cell</param>
        /// <returns>Returns right padding value of cell.</returns>
        private float GetRightPadding(WTableCell cell)
        {
            //Gets padding from cell format.
            float right = cell.CellFormat.Paddings.Right;

            //If cell has same padding as table, then get the paddings from row or table.
            if (cell.CellFormat.SamePaddingsAsTable)
            {
                WTable table = (cell.OwnerRow.Owner as WTable);
                //Gets the right paddings from row format.
                if (cell.OwnerRow.RowFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.RightKey))
                    right = cell.OwnerRow.RowFormat.Paddings.Right;
                //Gets the right paddings from table format.
                else if (table.TableFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.RightKey))
                    right = table.TableFormat.Paddings.Right;
                //Default value for cell paddings.
                else
                    right = 5.4f;
            }
            return right;
        }
        /// <summary>
        /// Gets bottom margin of the table cell.
        /// </summary>
        /// <param name="cell">Represents the table cell</param>
        /// <returns>Returns bottom padding value of cell.</returns>
        private float GetBottomPadding(WTableCell cell)
        {
            //Gets padding from cell format.
            float bottom = cell.CellFormat.Paddings.Bottom;

            //If cell has same padding as table, then get the paddings from row or table.
            if (cell.CellFormat.SamePaddingsAsTable)
            {
                WTable table = (cell.OwnerRow.Owner as WTable);
                //Gets the right paddings from row format.
                if (cell.OwnerRow.RowFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.BottomKey))
                    bottom = cell.OwnerRow.RowFormat.Paddings.Bottom;
                //Gets the right paddings from table format.
                else if (table.TableFormat.Paddings.HasKey(Syncfusion.DocIO.DLS.Paddings.BottomKey))
                    bottom = table.TableFormat.Paddings.Bottom;
                //Default value for cell paddings.
                else
                    bottom = 0;
            }
            return bottom;
        }
        #endregion        
    }
}

